Bug 974582 - /etc/rc.d/rc.local not being run on boot
/etc/rc.d/rc.local not being run on boot
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: initscripts (Show other bugs)
18
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Lukáš Nykrýn
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-14 09:33 EDT by Brian J. Murrell
Modified: 2014-02-05 16:49 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 16:49:41 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Brian J. Murrell 2013-06-14 09:33:47 EDT
Description of problem:
On boot, /etc/rc.d/rc.local is not being run.

Version-Release number of selected component (if applicable):
9.42.2-3.fc18.x86_64

How reproducible:
100%

Steps to Reproduce:
1. create /etc/rc.d/rc.local; chmod 755 /etc/rc.d/rc.local
2. put in above file some command that changes post-boot state. i.e. "echo 0 > /proc/sys/vm/swappiness"
3. reboot
4. cat /proc/sys/vm/swappiness

Actual results:
/proc/sys/vm/swappiness still has 60 in it

Expected results:
/proc/sys/vm/swappiness has 0 in it

Additional info:
Of course, you can change the above steps to any other method that proves to you that /etc/rc.d/rc.local is [not] being executed.
Comment 1 Bill Nottingham 2013-06-14 10:49:13 EDT
Does the script start with

#!/bin/sh

(or something equivalent?)
Comment 2 Bill Nottingham 2013-06-14 10:49:40 EDT
What does 'systemctl status rc-local.service' say?
Comment 3 Brian J. Murrell 2013-06-14 12:41:14 EDT
(In reply to Bill Nottingham from comment #1)
> Does the script start with
> 
> #!/bin/sh
> 
> (or something equivalent?)

It does now.  :-/  I guess next boot will reveal whether that was the problem.  I'm guessing it was.

(In reply to Bill Nottingham from comment #2)
> What does 'systemctl status rc-local.service' say?

rc-local.service - /etc/rc.d/rc.local Compatibility
   Loaded: loaded (/usr/lib/systemd/system/rc-local.service; static)
   Active: failed (Result: exit-code) since Fri 2013-06-14 10:26:03 EDT; 2h 14min ago
  Process: 1011 ExecStart=/etc/rc.d/rc.local start (code=exited, status=203/EXEC)

Does that look like it would be caused by the lack of #!/bin/sh?
Comment 4 Brian J. Murrell 2013-06-14 12:41:52 EDT
Maybe this could be avoided by having an empty, working /etc/rc.d/rc.local in place that one just needs to add one's commands to?
Comment 5 Bill Nottingham 2013-06-14 14:47:40 EDT
Yes, the exec error is 'exec format failed' - for it to run, it needs to be a valid shell script. (While this worked before systemd, it was a side-effect of it being started by a shell script instead of by the init daemon itself).

It's a bit of a tradeoff - if there's an empty one, it's run for everyone despite not being needed. If it's empty but set so it won't run (chmod -x), it still requires an admin action, it ends up showing up as an error when it's not one.
Comment 6 Brian J. Murrell 2013-06-24 07:37:33 EDT
So yeah, this is working now.

(In reply to Bill Nottingham from comment #5)
> 
> It's a bit of a tradeoff - if there's an empty one, it's run for everyone
> despite not being needed.

At negligible cost, compared to the cost of everyone having to spend the time to figure out and understand why/how it's different than it used to be.
Comment 7 Fedora Admin XMLRPC Client 2013-09-04 10:50:14 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 8 Fedora End Of Life 2013-12-21 09:00:57 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 9 Fedora End Of Life 2014-02-05 16:49:41 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.